
/******************************************************************
file name:def.h

******************************************************************/
#ifndef _DEF_H
#define _DEF_H


#define uint8_t unsigned char
#define uint16_t unsigned long int

/////////////////////////////////////////
struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;

	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};
//////////////////////////////////////////
typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
////////////////////////////////////////////
//sfr define for fc2824
////////////////////////////////////////////
//=================================================
//Ĵ궨
//=================================================
sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;

sbit	LVDF =0x86:5;
sbit	PWM10E		=0xA0:0;
//sfr	RBANK = 0x87;

 // sfr    TM0M    =0X90;
 // sfr    TM0CL   =0X91;
 // sfr    TM0CH   =0X92;
 // sfr    TM0D0L  =0X93;
 // sfr    TM0D0H  =0X94;
 // sfr    TM0D1L  =0X95;
 // sfr    TM0D1H  =0X96;
 // sfr    PWM0E   =0X97;

 // sfr	SPIC0	=0X98;
 // sfr	SPIC1	=0X99;
 // sfr	SPIBUF	=0X9A;

 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0XBe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P3W = 0XDE;    //
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;

 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	FP37UR = 0XE3:7;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAA:2;
sbit	E2P_PG		=0xA9:1;
sbit	E2P_RD		=0xA8:0;
///SPI CONTROL
sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;
////////////////////////////////////
//I2C CONTROL---------------------
sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;

///////////////////////////////////////////////////
//----OPTION CONTROL
sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;

///////////////////////////////////////////////////
///-------------ADC REGISTER-----------------------
//----ADM CONTROL
sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	FEOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	FADENB		=0xB9:7;


//----ADR CONTROL
sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;


//----ADT CONTROL
sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;

//----VREFH CONTROL
sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;



//////////////////////////////////////////////////////////////
//---------INTRUPT register ---------------------------
//inte
sbit	FINT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IE		=0xc9:2;
sbit	FTM1IE		=0xc9:3;
sbit	FTM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	FI2CIE		=0xc9:6;
sbit	FADCIE		=0xc9:7;
//inteN1
sbit	FE2PIE		=0xc7:0;
sbit	FTKTMRIE	=0xc7:1;
sbit	FSPIIE		=0xc7:2;
sbit	FT0IE	    =0xC7:3;
sbit	FOPAIE    	=0xC7:4;
//intRQ
sbit	FINT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IF		=0xc8:2;
sbit	FTM1IF		=0xc8:3;
sbit	FTM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	FI2CIF		=0xc8:6;
sbit	FADCIF		=0xc8:7;
//intRQ1
sbit	FE2PIF		=0xc6:0;
sbit	FTKTMRIF	=0xc6:1;
sbit	FSPIIF		=0xc6:2;
sbit	FT0IF	    =0xC6:3;
sbit	FOPAIF    	=0xC6:4;


sbit	FGIE = 0xdf:7;
/////////////////////////////////////////////////////
//P1
sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

//P3
sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;

/////////////////////////////////////////////////////
#define HIBYTE(wval)		*(((BYTE*)(&wval))+1)
#define LWBYTE(wval)		*(((BYTE*)(&wval))+0)

#define HIWORD(wval)		*(((WORD*)(&wval))+1)
#define LWWORD(wval)		*(((WORD*)(&wval))+0)
#define SLEEPMODE __asm{SleepMode}
#define GREENMODE __asm{GreenMode}
#define SLOWMODE __asm{SLowMode}
#define SLOW2NORMAL __asm{Slow2Normal}

#endif